import javax.swing.JTextField;
import java.awt.event.MouseEvent;
import java.util.Enumeration;
import javax.media.j3d.*;
import javax.vecmath.*;
import com.sun.j3d.utils.picking.*;

public class NameBehaviour extends Behavior {

	private WakeupCondition _wCond;
	private PickCanvas _pickCanvas;
	private JTextField _textField;
	
	// Constructor
	NameBehaviour(BranchGroup bg, Canvas3D canvas3D, JTextField textField, float tolerance) {

		//event that runs the processStimulus method
		_wCond = new WakeupOnAWTEvent(MouseEvent.MOUSE_PRESSED);
		_textField = textField;

		//create and initialize picking object
		_pickCanvas = new PickCanvas(canvas3D, bg);
		_pickCanvas.setTolerance(tolerance); //accuracy of picking
		_pickCanvas.setMode(PickCanvas.GEOMETRY_INTERSECT_INFO);
	}
	
	// Initialization
	public void initialize() {
		//start waiting for event
		wakeupOn(_wCond);
	}
	
	// Event handling
	public void processStimulus(Enumeration criteria) {
		_textField.setText(this.getUserData().toString());
		//start waiting for next event
		wakeupOn(_wCond);
	}
}// end class NameBehaviour
